<template>
    <div>
  <div class="page-title">
    <h3>Планирование</h3>
    <h4>{{ currencyFilter(info.bill)}} </h4>
  </div>

  <Loader v-if="loading" />

  <p v-else-if="!categories.length" class="center" >Categeory is null. <router-link to="/categories">For create a new category</router-link> </p>

  <section v-else >
    <div v-for="cat in categories" :key="cat.id">
      <p>
        <strong >{{cat.title}}:</strong>
        {{ currencyFilter(cat.spend)}} из {{ currencyFilter(cat.limit)}}
      </p>
      <div class="progress" v-tooltip="cat.tooltip" >
        <div
            class="determinate"
            :class="[cat.progressColor]"
            style="{width: cat.progressPercent + '%'}"
        ></div>
      </div>
    </div>
  </section>
</div>
</template>

<script>
import {mapGetters} from 'vuex'
export default{
  name: 'planning',
  computed:{
    ...mapGetters(['info'])
  },
  data:()=>({
    loading: true,
    categories:[]
  }),
  methods: {
    getCurrency(currency) {
      return Math.floor(this.base * this.rates[currency]);
    },
    currencyFilter(value, currency= "RUB") {
      const options = {
        style: "currency",
        currency
      };

      return new Intl.NumberFormat("uz-Uz", options).format(value);
    }
  },
  async mounted(){
    const records= await this.$store.dispatch('fetchRecords');
    const categories= await this.$store.dispatch('fetchCategories');

    this.categories=categories.map(cat => {
      const spend=records
      .filter(r => r.categoryId === cat.id)
      .filter(r => r.type === 'outcome')
      .reduce((total, record)=>{
        return total+= + record.amount;
      },0);

      const persent=100*spend/cat.limit;
      const progressPercent=persent>100 ?100:persent;
      const progressColor=persent<60
      ? 'green' 
      : persent<100
        ? 'yellow' : 'red'

      const tooltipValue=cat.limit- spend;
      const tooltip=`${tooltipValue<0 ?'Out of limit': 'Residual '} ${Math.abs(tooltipValue)}`

      return {
        ...cat,
        progressPercent,
        progressColor,
        spend,
        tooltip
      }


    })

    this.loading=false;
  }
}
</script>